# Python code to cat many files
#
# Jason Chang
# February 2016

#----------------------------------------
# import modules
#----------------------------------------
import sys
import commands
import random


#----------------------------------------
# script parameters
#----------------------------------------
tmp_num = random.randint(0,10000)
axx = 4
SEP = '/opt/SEP/SEP8.1/bin'


#----------------------------------------
# parse command line
#----------------------------------------
def parse_commandline():
  # check number of arguments
  if (len(sys.argv) < 1):
    print "Usage:"
    print "     python %s [output file] [files to cat]" %(sys.argv[0])
    sys.exit()

  # grab files
  outfile = sys.argv[1]
  files = []
  count = 1
  while 1:
    # counter
    count = count+1

    # determine whether argument exists or not
    try:
      files.append(sys.argv[count])
    except:
      break

  # clean up
  return outfile,files


#----------------------------------------
# function for catting files
#----------------------------------------
def cat_files(fnames,target):
  block=20
  nfiles=len(fnames)

  count2=0
  while 1:
    total=len(fnames)
    cnames = []

    count1=0
    if (total//block>1):
      # For all complete blocks
      for ii in range(total//block):
        names = fnames[(count1)*block:(count1+1)*block]
        cname = 'temp%s_%i.H' %(str(count2),tmp_num)
        print "%s/Scat3d %s axis=%s > %s" %(SEP," ".join(names),axx,cname)
        print commands.getstatusoutput("%s/Scat3d max_memory=1000 %s axis=%s > %s" %(SEP," ".join(names),axx,cname))
        cnames.append(cname)
        count1 = count1+1
        count2 = count2+1

      # For the remainder complete blocks
      if (total%block==1): # If only one file
        cname = fnames[count1*block]
        cnames.append(cname)

        count1 = count1+1
        count2 = count2+1

      if (total%block>1):
        names = fnames[count1*block:count1*block+total%block]
        cname = 'temp%s_%i.H' %(str(count2),tmp_num)
        print "%s/Scat3d %s axis=%s > %s" %(SEP," ".join(names),axx,cname)
        print commands.getstatusoutput("%s/Scat3d max_memory=1000 %s axis=%s > %s" %(SEP," ".join(names),axx,cname))
        cnames.append(cname)
        count1 = count1+1
        count2 = count2+1

      # Repeat with new list
      fnames=cnames

    else:
      names = fnames
      print "%s/Scat3d %s axis=%s > %s" %(SEP," ".join(names),axx,target)
      print commands.getstatusoutput("%s/Scat3d max_memory=1000 %s axis=%s > %s" %(SEP," ".join(names),axx,target))
      cnames.append(target)
      break



#----------------------------------------
# run commands
#----------------------------------------
outfile,files = parse_commandline()
cat_files(files,outfile)
